<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-subtitle1"
              :class="isIrrigated ? 'q-mb-sm' : ''"
            >
              <translate>Nitrogen in water:</translate>
            </div>

            <q-input
              :filled="isIrrigated"
              :disabled="!isIrrigated"
              :readonly="!isIrrigated"
              type="number"
              :min="nInWaterMin"
              :max="nInWaterMax"
              :suffix="$gettext('ppm')"
              v-model="storeNitrogenInWater"
              :rules="shouldBeANumberRules"
            >
              <template
                #hint
                v-if="!isIrrigated"
              >
                <translate>Only relevant for irrigated crops</translate>
              </template>
            </q-input>

            <div
              class="text-subtitle1"
              :class="isIrrigated ? 'q-mb-sm q-mt-sm' : 'q-mt-lg'"
            >
              <translate>Irrigation dotation:</translate>
            </div>

            <q-input
              :filled="isIrrigated"
              :disabled="!isIrrigated"
              :readonly="!isIrrigated"
              type="number"
              min="0"
              :suffix="$pgettext('unit', 'm3/ha')"
              v-model="storeIrrigationDotation"
              :rules="shouldBeANumberRules"
            >
              <template
                #hint
                v-if="!isIrrigated"
              >
                <translate>Only relevant for irrigated crops</translate>
              </template>
            </q-input>

            <div
              class="text-subtitle1 q-mb-sm q-mt-xl"
            >
              <translate>Nitrogen in soil at start of season:</translate>
            </div>

            <q-input
              filled
              type="number"
              min="0"
              :suffix="$gettext('kg/ha')"
              v-model="storeNitrogenInSoil"
              :rules="shouldBeANumberRules"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import FertilicalcMixin from 'src/pages/fieldbook/fertilization/algorithms/fertilicalc/mixins/FertilicalcMixin'

import queryPlotWaterDerivedObjects from 'src/pages/fieldbook/fertilization/algorithms/fertilicalc/graphql/queryPlotWaterDerivedObjects'

export default {
  name: 'FertilicalcStrategyPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, FertilicalcMixin],
  data () {
    return {
      plotWaterDerivedObjects: [],
      hasLoadedPlotWaterDerivedObjects: false
    }
  },
  mounted () {
    if (this.storeNitrogenInSoil == null) {
      this.storeNitrogenInSoil = 0
    }
    if (this.storeIrrigationDotation == null && this.isIrrigated) {
      this.storeIrrigationDotation = this.$store.state.fertilizationPlan.parameters?.plant_species_profile?.sd_water_allocation_volume
    }
  },
  computed: {
    isIrrigated () {
      return this.$store.state.fertilizationPlan.parameters?.irrigation_method?.value === 'IRRIGATED'
    },
    canContinue () {
      return this.storeNitrogenInSoil != null &&
        this.isIrrigated
        ? this.storeNitrogenInWater != null && this.storeIrrigationDotation != null
        : true
    },
    pageTitle () {
      return this.$gettext('Nitrogen')
    },
    pageSubTitle () {
      return 'FertiliCalc'
    },
    shouldBeANumberRules () {
      return [
        val => !isNaN(val) || `${this.$gettext('Value must be a number')}`,
        val => val === 0 || !!val || `* ${this.$gettext('This field is required')}`
      ]
    },
    storeIrrigationDotation: {
      get () {
        return this.$store.state.fertilizationPlan?.parameters?.irrigation_dotation ?? null
      },
      set (value) {
        isNaN(value)
          ? this.updateParameter('irrigation_dotation', null)
          : this.updateParameter('irrigation_dotation', Number(value < 0 ? 0 : value))
      }
    },
    storeNitrogenInWater: {
      get () {
        return this.$store.state.fertilizationPlan?.parameters?.nitrogen_in_water ?? null
      },
      set (value) {
        isNaN(value)
          ? this.updateParameter('nitrogen_in_water', null)
          : this.updateParameter('nitrogen_in_water', Number(value < this.nInWaterMin ? this.nInWaterMin : value > this.nInWaterMax ? this.nInWaterMax : value))
      }
    },
    storeNitrogenInSoil: {
      get () {
        return this.$store.state.fertilizationPlan?.parameters?.nitrogen_in_soil ?? null
      },
      set (value) {
        isNaN(value)
          ? this.updateParameter('nitrogen_in_soil', null)
          : this.updateParameter('nitrogen_in_soil', Number(value < 0 ? 0 : value))
      }
    }
  },
  apollo: {
    plotWaterDerivedObjects: {
      query: queryPlotWaterDerivedObjects,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.$store.state.fertilizationPlan?.target?.id
        }
      },
      update (data) {
        this.hasLoadedPlotWaterDerivedObjects = true
        if (this.storeNitrogenInWater == null) {
          const nInWaterObservation = data.plot_by_pk.water_derived_objects?.[0]?.water_derived_observations?.find(wdo => wdo.observable_property.id === 'n_in_water')
          if (nInWaterObservation) {
            if (nInWaterObservation?.observable_property?.unit_of_measure?.id === 'ppm') {
              this.storeNitrogenInWater = nInWaterObservation.result.value
            }
          }
        }
        return data.plot_by_pk.water_derived_objects
      },
      skip () {
        return !this.isIrrigated
      }
    }
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'fertilicalcCompute'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'fertilicalcSoil'
      })
    }
  }
}
</script>
